/**
 * 
 */
package cytoscape.PFPPipeline;

/**
 * @author Hafeez
 *
 */

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.lang.reflect.Member;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.cytoscape.equations.builtins.Last;
import org.hupo.psi.mi.psicquic.wsclient.PsicquicSimpleClient;
import org.omg.CORBA.PUBLIC_MEMBER;

public class Interactions {

	private String intAct_URL;
	private String DIP_URL;
	//public static List<String> interactors;
	//public static Set<String> uniqueInteractors;
	public static ArrayList<InteractorProtein> interactorProteins;
	public static InteractorProtein queryProtein;
	boolean updateQueryinfo;
	public String uniProtName,uniProtSpecie; // Atrributes retreived from Uniprot.

	public Interactions() {
		// TODO Auto-generated constructor stub		
		DIP_URL = "http://imex.mbi.ucla.edu/psicquic-ws/webservices/current/search/";
		intAct_URL = "http://www.ebi.ac.uk/Tools/webservices/psicquic/intact/webservices/current/search/";
		//interactors = new ArrayList<String>();
		interactorProteins= new ArrayList<InteractorProtein>();		
	}

	public void searchInteractions(String query) {
		// JOptionPane.showMessageDialog(null, "in search interactions...");
		queryProtein= new InteractorProtein(query);
		queryUniProt(query);
//		System.out.println("name: "+this.uniProtName+" specie: "+this.uniProtSpecie);
		if(this.uniProtName!=null){
		queryProtein.setName(this.uniProtName);}else{queryProtein.setName("N-A");}
		if(this.uniProtSpecie!=null){
		queryProtein.setSpecies(this.uniProtSpecie);}else{queryProtein.setSpecies("N-A");}
		
		getInteractions(query, intAct_URL);
		getInteractions(query, DIP_URL);		
	}

	public void getInteractions(String query, String db) {
		
		PsicquicSimpleClient client = new PsicquicSimpleClient(db);
		try {
			final long count = client.countByQuery(query);

//			System.out.println("Interactors from : "+db+" Count: "+count);

			final InputStream result = client.getByQuery(query);
			BufferedReader in = new BufferedReader(
					new InputStreamReader(result));

			String line;
			String database;
//			FOR DATABASE
			if(db.equals(intAct_URL)){
				database="IntAct Database";
			}
			else{
				database="DIP Database";
			}

			while ((line = in.readLine()) != null) {
				String id,names, exp,specie,name,intType;
//				System.out.println(line);
				String interactor1, interactor2;
				interactor1 = line.split("\\t")[0].trim();
				interactor2 = line.split("\\t")[1].trim();
				if (interactor1.contains(query) || interactor2.contains(query)) {
					if (interactor1.indexOf("uniprot") > -1
							&& interactor2.indexOf("uniprot") > -1) {
						int lin = interactor1.indexOf("uniprotkb");
						interactor1 = interactor1.substring(lin + 10, lin + 16);
						lin = interactor2.indexOf("uniprotkb");
						interactor2 = interactor2.substring(lin + 10, lin + 16);

						if (interactor1.equals(query)) {
							// Check if it's not a self interaction
							if (!interactor2.equals(query)) {
								//interactors.add(interactor2);								
//								FOR ID
								id=interactor2;
//								FOR NAME
								names = line.split("\\t")[5].trim();
								if(names.contains("uniprotkb:") && names.contains("(gene name synonym)")){								  
								  name=names.substring(0, names.lastIndexOf("(gene name synonym)"));
								  name=name.substring(name.lastIndexOf(":")+1);								   
								 }else{
									 queryUniProt(id);
									name=this.uniProtName;
								 	}
//								FOR EXPERIMENT
								exp = line.split("\\t")[6].trim();
								if(exp.contains("(")){									
									exp=exp.substring(exp.lastIndexOf("(")+1, exp.lastIndexOf(")"));
								}else{exp="N-A";}
//								FOR INTERACTION TYPE
								intType = line.split("\\t")[11].trim();
								if(intType.contains("(")){									
									intType=intType.substring(intType.lastIndexOf("(")+1, intType.lastIndexOf(")"));
								}else{exp="N-A";}
								
//								FOR SPECIES								
								specie = line.split("\\t")[10].trim();
								if(specie.contains("taxid:")){ 
									specie=specie.substring(specie.indexOf(":")+1, specie.indexOf("("));
								}
//								System.out.println("name2: "+name);
//								System.out.println("Exp: "+exp+" Species: "+specie+" type: "+intType+" db:"+database);
								boolean found=false;
								if(interactorProteins.size()>0){
								
								Iterator<InteractorProtein> proIt= interactorProteins.iterator();
								
								while(proIt.hasNext()){
									InteractorProtein interactor=proIt.next();
									if(interactor.uniprotID.equals(id)){
										found=true;
										interactor.experimentCount+=1;
									}
								}
								if(found==false){
//									NEW INTERACTOR
									InteractorProtein intPro=new InteractorProtein(id);
									intPro.setName(name);
									intPro.setSpecies(specie);
									intPro.setDatabase(database);
									intPro.setInteractionDectectionExp(exp);
									intPro.setInteractionType(intType);
									intPro.setExperimentCount(1);
									interactorProteins.add(intPro);
									
								}
								}else{
//									NEW INTERACTOR(1st)
									InteractorProtein intPro=new InteractorProtein(id);
									intPro.setName(name);
									intPro.setSpecies(specie);
									intPro.setDatabase(database);
									intPro.setInteractionDectectionExp(exp);
									intPro.setInteractionType(intType);
									intPro.setExperimentCount(1);
									interactorProteins.add(intPro);									
								}
								
							}

						} else {
							//interactors.add(interactor1);
//							FOR ID
							id=interactor1;
//							FOR NAME
							names = line.split("\\t")[4].trim();
							if(names.contains("uniprotkb:") && names.contains("(gene name synonym)")){								  
								  name=names.substring(0, names.lastIndexOf("(gene name synonym)"));
								  name=name.substring(name.lastIndexOf(":")+1);
								  }else{
								queryUniProt(id);
								name=this.uniProtName;
							}
//							FOR EXPERIMENT
							exp = line.split("\\t")[6].trim();
							if(exp.contains("(")){									
								exp=exp.substring(exp.lastIndexOf("(")+1, exp.lastIndexOf(")"));
							}else{exp="N-A";}
//							FOR INTERACTION TYPE
							intType = line.split("\\t")[11].trim();
							if(intType.contains("(")){									
								intType=intType.substring(intType.lastIndexOf("(")+1, intType.lastIndexOf(")"));
							}else{exp="N-A";}
//							FOR SPECIES
							specie = line.split("\\t")[9].trim();
							if(specie.contains("taxid:")){
								specie=specie.substring(specie.indexOf(":")+1, specie.indexOf("("));
							}else{specie="N-A";}
							
																					
//							System.out.println("name1: "+name);
//							System.out.println("Exp: "+exp+" Species: "+specie+" type: "+intType+" db: "+database);
							boolean found=false;
							if(interactorProteins.size()>0){
							
							Iterator<InteractorProtein> proIt= interactorProteins.iterator();
							
							while(proIt.hasNext()){
								InteractorProtein interactor=proIt.next();
								if(interactor.uniprotID.equals(id)){
									found=true;
									interactor.experimentCount+=1;
								}
							}
							if(found==false){
//								NEW INTERACTOR
								InteractorProtein intPro=new InteractorProtein(id);
								intPro.setName(name);
								intPro.setSpecies(specie);
								intPro.setDatabase(database);
								intPro.setInteractionDectectionExp(exp);
								intPro.setInteractionType(intType);
								intPro.setExperimentCount(1);
								interactorProteins.add(intPro);
								
							}
							}else{
//								NEW INTERACTOR(1st)
								InteractorProtein intPro=new InteractorProtein(id);
								intPro.setName(name);
								intPro.setSpecies(specie);
								intPro.setDatabase(database);
								intPro.setInteractionDectectionExp(exp);
								intPro.setInteractionType(intType);
								intPro.setExperimentCount(1);
								interactorProteins.add(intPro);									
							}
							
						}

					}

				}

			}
			//uniqueInteractors = new HashSet<String>(interactors);
//			System.out.println("Siiize: "+interactorProteins.size());

			in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		/*
		 * System.out.println("Unique Interactors...\n"+uniqueInteractors.size())
		 * ; Iterator<String> iterator= uniqueInteractors.iterator();
		 * 
		 * while(iterator.hasNext()) { System.out.println(iterator.next()); }
		 */

	}
	public void queryUniProt(String protein){


		// TODO Auto-generated method stub
		List<String> functions = new ArrayList<String>();

		try {
			URL url = new URL("http://www.uniprot.org/uniprot/" + protein
					+ ".txt");
			String query = "";
			// make connection
			URLConnection urlc = url.openConnection();

			// use post mode
			urlc.setDoOutput(true);
			urlc.setAllowUserInteraction(false);
			// send query
			PrintStream ps = new PrintStream(urlc.getOutputStream());
			ps.print(query);
			ps.close();

			// get result
			BufferedReader br = new BufferedReader(new InputStreamReader(
					urlc.getInputStream()));
			String l = null;

//			int i = 0;

			while ((l = br.readLine()) != null) {
				//System.out.println(l);
				// l.split("\t")[0]
				if (l.startsWith("OX")) {
					this.uniProtSpecie=l.substring(l.lastIndexOf("=")+1, l.lastIndexOf(";"));
					break;
				}
				if(l.startsWith("DE")&&l.contains("Full")){					
					this.uniProtName=l.substring(l.lastIndexOf("Full=")+5,l.lastIndexOf(";"));
				}	
				
//				i++;
			}
			/*

			if (functions.size() > 0) {
				for (i = 0; i < functions.size(); i++)
					System.out.println(functions.get(i));
			}*/
		}

		catch (IOException e) {

		}
		
	
	}
	
	public class InteractorProtein
	{
//		Class Members
		private String uniprotID; //Uniprot id
		private String name; // Protein Name
		private String interactionDectectionExp; // Experiment that reports the interaction.
		private String interactionType;//Type of interation among proteins
		private String species;// Specie of the interactor.		
		private int experimentCount;//Number of experiments report this interaction.
		private String database;// Database reporting this interaction.
		private Double interactorPISValue;
		
//		Member Functions
		public InteractorProtein(String id){
			this.uniprotID=id;			
		}
		
		public void setUniprotID(String id){
			this.uniprotID=id;
		}
		public String getUniprotID(){
			return this.uniprotID;
		}
		
		public void setName(String name){
			this.name=name;
		}
		public String getName(){
			return this.name;
		}
		
		public void setInteractionDectectionExp(String exp){
			this.interactionDectectionExp= exp;
		}
		public String getInteractionDectectionExp(){
			return this.interactionDectectionExp;
		}
		
		public void setInteractionType(String type){
			this.interactionType= type;
		}
		public String getInteractionType(){
			return this.interactionType;
		}
				
		public void setSpecies(String sp){
			this.species=sp;
		}
		public String getSpecies(){
			return this.species;
		}
		
		public void setExperimentCount(int count){
			this.experimentCount=count;
		}
		public int getExperimentCount(){
			return this.experimentCount;
		}
		
		public void setDatabase(String db){
			this.database=db;
		}
		public String getDatabase(){
			return this.database;
		}
		public void setPISValue(Double v){
			this.interactorPISValue=v;
		}
		public Double getPISValue(){
			return this.interactorPISValue;
		}
		
	}

}
